<?php
namespace Bushelpowered\Api\Aggregator\Quoting\V1\Response;
        
class ServiceFeeResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var \Bushelpowered\Api\Quoting\V1\Enums\ServiceFeeType $feeType */
    public \Bushelpowered\Api\Quoting\V1\Enums\ServiceFeeType $feeType;
    /** @var string $description */
    public string $description;
    /** @var float $amount */
    public float $amount;
    /** @var string $createdBy */
    public string $createdBy;
    /** @var string $updatedBy */
    public string $updatedBy;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  \Bushelpowered\Api\Quoting\V1\Enums\ServiceFeeType  $feeType 
     * @param  string  $description 
     * @param  float  $amount 
     * @param  string  $createdBy 
     * @param  string  $updatedBy 
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, \Bushelpowered\Api\Quoting\V1\Enums\ServiceFeeType $feeType, string $description, float $amount, string $createdBy, string $updatedBy, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->feeType = $feeType;
        $this->description = $description;
        $this->amount = $amount;
        $this->createdBy = $createdBy;
        $this->updatedBy = $updatedBy;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}