<?php
namespace Bushelpowered\Api\Aggregator\Statement\V1\Model;
        
class StatementListItem 
{
    /** @var string $id The primary unique identifier.*/
    public string $id;
    /** @var string $displayId The unique identifier to show users.*/
    public string $displayId;
    /** @var null|string $accountId The account identifier.*/
    public ?string $accountId = null;
    /** @var string $accountName The name of the account.*/
    public string $accountName;
    /** @var string $currency The currency associated with the balances e.g. USD, CAD.*/
    public string $currency;
    /** @var string $totalBalance The total formatted financial obligation reported for this time period.*/
    public string $totalBalance;
    /** @var float $totalBalanceNumeric The total financial obligation reported for this time period.*/
    public float $totalBalanceNumeric;
    /** @var string $balanceDue The immediate formatted financial obligation reported for the time report.*/
    public string $balanceDue;
    /** @var float $balanceDueNumeric The immediate financial obligation reported for the time report.*/
    public float $balanceDueNumeric;
    /** @var string $issueDate The date the statement was issued to the customer. of yyyy-MM-dd format, IE: 2023-10-04*/
    public string $issueDate;
    /** @var string $dueDate The date the statement’s balance is due. of yyyy-MM-dd format, IE: 2023-10-04*/
    public string $dueDate;
    /** @var null|string $status The standardized status for the statement received.*/
    public ?string $status = null;

    /**
     * @param  string  $id The primary unique identifier.
     * @param  string  $displayId The unique identifier to show users.
     * @param  null|string  $accountId The account identifier.
     * @param  string  $accountName The name of the account.
     * @param  string  $currency The currency associated with the balances e.g. USD, CAD.
     * @param  string  $totalBalance The total formatted financial obligation reported for this time period.
     * @param  float  $totalBalanceNumeric The total financial obligation reported for this time period.
     * @param  string  $balanceDue The immediate formatted financial obligation reported for the time report.
     * @param  float  $balanceDueNumeric The immediate financial obligation reported for the time report.
     * @param  string  $issueDate The date the statement was issued to the customer. of yyyy-MM-dd format, IE: 2023-10-04
     * @param  string  $dueDate The date the statement’s balance is due. of yyyy-MM-dd format, IE: 2023-10-04
     * @param  null|string  $status The standardized status for the statement received.
     */
    public function __construct(string $id, string $displayId, ?string $accountId, string $accountName, string $currency, string $totalBalance, float $totalBalanceNumeric, string $balanceDue, float $balanceDueNumeric, string $issueDate, string $dueDate, ?string $status)
    {
        $this->id = $id;
        $this->displayId = $displayId;
        $this->accountId = $accountId;
        $this->accountName = $accountName;
        $this->currency = $currency;
        $this->totalBalance = $totalBalance;
        $this->totalBalanceNumeric = $totalBalanceNumeric;
        $this->balanceDue = $balanceDue;
        $this->balanceDueNumeric = $balanceDueNumeric;
        $this->issueDate = $issueDate;
        $this->dueDate = $dueDate;
        $this->status = $status;
    }
    

}