<?php
namespace Bushelpowered\Api\Fulfillment\Configuration\V1\Response;
        
class CommodityResponse 
{
    /** @var string $code The commodity code. Used on the Threshold request/response for commodityId. Examples (corn, wheat, soybeans)*/
    public string $code;
    /** @var string $name The commodity name*/
    public string $name;
    /** @var \Bushelpowered\Api\Fulfillment\Configuration\V1\Response\RemarkResponse[] $supportedRemarks The remarks that are supported for creating a threshold*/
    public array $supportedRemarks;

    /**
     * @param  string  $code The commodity code. Used on the Threshold request/response for commodityId. Examples (corn, wheat, soybeans)
     * @param  string  $name The commodity name
     * @param  \Bushelpowered\Api\Fulfillment\Configuration\V1\Response\RemarkResponse[]  $supportedRemarks The remarks that are supported for creating a threshold
     */
    public function __construct(string $code, string $name, array $supportedRemarks)
    {
        $this->code = $code;
        $this->name = $name;
        $this->supportedRemarks = $supportedRemarks;
    }
    

}