<?php
namespace Bushelpowered\Api\Iam\Keycloak\V1\Model;
        
class LoginEventDetails 
{
    /** @var \Bushelpowered\Api\Iam\Keycloak\V1\Model\LoginEventType $loginType */
    public \Bushelpowered\Api\Iam\Keycloak\V1\Model\LoginEventType $loginType;
    /** @var string $timestamp When the login event occurred. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $timestamp;
    /** @var string $clientId The client that the user is logging into.*/
    public string $clientId;
    /** @var null|string $ipAddress Ip address of the user who is currently logging in.*/
    public ?string $ipAddress = null;
    /** @var null|string $sessionId Device token of the user.*/
    public ?string $sessionId = null;
    /** @var null|string $username The username that the user attempted to sign in with.*/
    public ?string $username = null;
    /** @var null|string $userId The bushel id of the user that the user is attempting to sign in to if it exists.*/
    public ?string $userId = null;
    /** @var null|string $acr The current acr level of the user if they are logged in.*/
    public ?string $acr = null;
    /** @var null|int $loa The current level of authentication that the user has if the user is already logged in.*/
    public ?int $loa = null;
    /** @var null|\Bushelpowered\Api\Iam\Keycloak\V1\Model\LoginAuthenticator $authenticator */
    public ?\Bushelpowered\Api\Iam\Keycloak\V1\Model\LoginAuthenticator $authenticator = null;
    /** @var bool $successful If the user passed the authenticator.*/
    public bool $successful;
    /** @var null|string $failureReason If the user failed, the reason why they failed.*/
    public ?string $failureReason = null;
    /** @var null|string $identityProvider The identity provider that the user action belongs to or that they logged in with.*/
    public ?string $identityProvider = null;

    /**
     * @param  \Bushelpowered\Api\Iam\Keycloak\V1\Model\LoginEventType  $loginType 
     * @param  string  $timestamp When the login event occurred. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $clientId The client that the user is logging into.
     * @param  null|string  $ipAddress Ip address of the user who is currently logging in.
     * @param  null|string  $sessionId Device token of the user.
     * @param  null|string  $username The username that the user attempted to sign in with.
     * @param  null|string  $userId The bushel id of the user that the user is attempting to sign in to if it exists.
     * @param  null|string  $acr The current acr level of the user if they are logged in.
     * @param  null|int  $loa The current level of authentication that the user has if the user is already logged in.
     * @param  null|\Bushelpowered\Api\Iam\Keycloak\V1\Model\LoginAuthenticator  $authenticator 
     * @param  bool  $successful If the user passed the authenticator.
     * @param  null|string  $failureReason If the user failed, the reason why they failed.
     * @param  null|string  $identityProvider The identity provider that the user action belongs to or that they logged in with.
     */
    public function __construct(\Bushelpowered\Api\Iam\Keycloak\V1\Model\LoginEventType $loginType, string $timestamp, string $clientId, ?string $ipAddress, ?string $sessionId, ?string $username, ?string $userId, ?string $acr, ?int $loa, ?\Bushelpowered\Api\Iam\Keycloak\V1\Model\LoginAuthenticator $authenticator, bool $successful, ?string $failureReason, ?string $identityProvider)
    {
        $this->loginType = $loginType;
        $this->timestamp = $timestamp;
        $this->clientId = $clientId;
        $this->ipAddress = $ipAddress;
        $this->sessionId = $sessionId;
        $this->username = $username;
        $this->userId = $userId;
        $this->acr = $acr;
        $this->loa = $loa;
        $this->authenticator = $authenticator;
        $this->successful = $successful;
        $this->failureReason = $failureReason;
        $this->identityProvider = $identityProvider;
    }
    

}