<?php
namespace Bushelpowered\Api\Platform\Authorization\V1\Event;
        
class AccountRoles 
{
    /** @var string $sourceId The id for the account in the remote system*/
    public string $sourceId;
    /** @var string $integrationId The global unique identifier of the source record, often concatenation of the datasource and source identifiers to ensure uniqueness.*/
    public string $integrationId;
    /** @var null|string $sourceName The name of the account in the remote system.*/
    public ?string $sourceName = null;
    /** @var string[]|null $roles The IDs of the roles to provide for this IdentifierAccount. If the roles property is null, the default role will be assumed.*/
    public ?array $roles = null;

    /**
     * @param  string  $sourceId The id for the account in the remote system
     * @param  string  $integrationId The global unique identifier of the source record, often concatenation of the datasource and source identifiers to ensure uniqueness.
     * @param  null|string  $sourceName The name of the account in the remote system.
     * @param  string[]|null  $roles The IDs of the roles to provide for this IdentifierAccount. If the roles property is null, the default role will be assumed.
     */
    public function __construct(string $sourceId, string $integrationId, ?string $sourceName, ?array $roles)
    {
        $this->sourceId = $sourceId;
        $this->integrationId = $integrationId;
        $this->sourceName = $sourceName;
        $this->roles = $roles;
    }
    

}