<?php
namespace Bushelpowered\Api\Platform\Eventstore\V1\Response;
        
class GetEventsResponse implements \Bushelpowered\Api\Common\ReturnsPaginationTokens
{
    /** @var \Bushelpowered\Api\Platform\Eventstore\V1\Common\Event[] $events */
    public array $events;
    /** @var null|string $continuationToken A service-generated token encoding current pagination state. <br>Clients SHOULD NOT attempt to manufacture continuation tokens.*/
    public ?string $continuationToken = null;

    /**
     * @param  \Bushelpowered\Api\Platform\Eventstore\V1\Common\Event[]  $events 
     * @param  null|string  $continuationToken A service-generated token encoding current pagination state. <br>Clients SHOULD NOT attempt to manufacture continuation tokens.
     */
    public function __construct(array $events, ?string $continuationToken)
    {
        $this->events = $events;
        $this->continuationToken = $continuationToken;
    }
    
    /**
     * @return null|string A service-generated token encoding current pagination state. <br>Clients SHOULD NOT attempt to manufacture continuation tokens.
     */
    public function getContinuationToken(): ?string
    {
        return $this->continuationToken;
    }
}