<?php

namespace Bushelpowered\Api\Platform\File\V1\Common;

class ContentDisposition
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'attachment' => '\Bushelpowered\Api\Platform\File\V1\Common\AttachmentContentDisposition',
        'inline' => '\Bushelpowered\Api\Platform\File\V1\Common\InlineContentDisposition',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Attachment(\Bushelpowered\Api\Platform\File\V1\Common\AttachmentContentDisposition $data): ContentDisposition
    {
        return new ContentDisposition('attachment', $data);
    }
    public static function Inline(\Bushelpowered\Api\Platform\File\V1\Common\InlineContentDisposition $data): ContentDisposition
    {
        return new ContentDisposition('inline', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    