<?php

namespace Bushelpowered\Api\Platform\File\V1\Common;

class Resize
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'proportional' => '\Bushelpowered\Api\Platform\File\V1\Common\ProportionalResize',
        'stretch' => '\Bushelpowered\Api\Platform\File\V1\Common\StretchResize',
        'crop' => '\Bushelpowered\Api\Platform\File\V1\Common\CropResize',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Proportional(\Bushelpowered\Api\Platform\File\V1\Common\ProportionalResize $data): Resize
    {
        return new Resize('proportional', $data);
    }
    public static function Stretch(\Bushelpowered\Api\Platform\File\V1\Common\StretchResize $data): Resize
    {
        return new Resize('stretch', $data);
    }
    public static function Crop(\Bushelpowered\Api\Platform\File\V1\Common\CropResize $data): Resize
    {
        return new Resize('crop', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    