<?php

namespace Bushelpowered\Api\Platform\Message\V1\Request;

class Channel
{
    public string $type;
    public $data;
    private \JsonMapper $mapper;

    private static $types = [
        'email' => '\Bushelpowered\Api\Platform\Message\V1\Request\EmailChannel',
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Email(\Bushelpowered\Api\Platform\Message\V1\Request\EmailChannel $data): Channel
    {
        return new Channel('email', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    