<?php
namespace Bushelpowered\Api\Platform\Tenant\V1\Model;
        
class DatasourceStandard implements \Bushelpowered\Api\Common\HasTimestamps
{
    /** @var string $id */
    public string $id;
    /** @var \Bushelpowered\Api\Platform\Tenant\V1\Model\TenantStandard $tenant */
    public \Bushelpowered\Api\Platform\Tenant\V1\Model\TenantStandard $tenant;
    /** @var null|string $slug */
    public ?string $slug = null;
    /** @var string $name The name of the datasource, which corresponds directly to the 'company name' field in Centre.*/
    public string $name;
    /** @var null|string $erpType The enterprise resource provider type identifier.*/
    public ?string $erpType = null;
    /** @var null|string $dataIngestionType This signifies if the data was pushed or pulled from the ag business*/
    public ?string $dataIngestionType = null;
    /** @var null|string $comments The comments identifier.*/
    public ?string $comments = null;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;
    /** @var null|string $deletedAt Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deletedAt = null;

    /**
     * @param  string  $id 
     * @param  \Bushelpowered\Api\Platform\Tenant\V1\Model\TenantStandard  $tenant 
     * @param  null|string  $slug 
     * @param  string  $name The name of the datasource, which corresponds directly to the 'company name' field in Centre.
     * @param  null|string  $erpType The enterprise resource provider type identifier.
     * @param  null|string  $dataIngestionType This signifies if the data was pushed or pulled from the ag business
     * @param  null|string  $comments The comments identifier.
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deletedAt Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, \Bushelpowered\Api\Platform\Tenant\V1\Model\TenantStandard $tenant, ?string $slug, string $name, ?string $erpType, ?string $dataIngestionType, ?string $comments, string $createdAt, string $updatedAt, ?string $deletedAt)
    {
        $this->id = $id;
        $this->tenant = $tenant;
        $this->slug = $slug;
        $this->name = $name;
        $this->erpType = $erpType;
        $this->dataIngestionType = $dataIngestionType;
        $this->comments = $comments;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
    /**
     * @return null|string Deleted date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getDeletedAt(): ?string
    {
        return $this->deletedAt;
    }
}