<?php
namespace Bushelpowered\Api\Platform\User\V1\Pagination;
        
class StaffUserPagination implements \Bushelpowered\Api\Common\PaginationBase
{
    /** @var \Bushelpowered\Api\Platform\User\V1\Pagination\StaffUserSortPlan[]|null $sortPlan List of column and sort direction*/
    public ?array $sortPlan = null;
    /** @var null|string $token A continuation token.*/
    public ?string $token = null;
    /** @var null|int $pageSize The desired size of pages, subject to service-imposed limitations.*/
    public ?int $pageSize = null;

    /**
     * @param  \Bushelpowered\Api\Platform\User\V1\Pagination\StaffUserSortPlan[]|null  $sortPlan List of column and sort direction
     * @param  null|string  $token A continuation token.
     * @param  null|int  $pageSize The desired size of pages, subject to service-imposed limitations.
     */
    public function __construct(?array $sortPlan, ?string $token, ?int $pageSize)
    {
        $this->sortPlan = $sortPlan;
        $this->token = $token;
        $this->pageSize = $pageSize;
    }
    
    /**
     * @return null|string A continuation token.
     */
    public function getToken(): ?string
    {
        return $this->token;
    }
    /**
     * @return null|int The desired size of pages, subject to service-imposed limitations.
     */
    public function getPageSize(): ?int
    {
        return $this->pageSize;
    }
}