<?php
namespace Bushelpowered\Api\Quoting\V1\Request;
        
class UpsertServiceRequestRequest 
{
    /** @var null|string $id The id of the record to update, will be created if null*/
    public ?string $id = null;
    /** @var \Bushelpowered\Api\Quoting\V1\Enums\ServiceFeeType $serviceType */
    public \Bushelpowered\Api\Quoting\V1\Enums\ServiceFeeType $serviceType;
    /** @var string $description */
    public string $description;
    /** @var null|string $serviceDate  of yyyy-MM-dd format, IE: 2023-10-04*/
    public ?string $serviceDate = null;

    /**
     * @param  null|string  $id The id of the record to update, will be created if null
     * @param  \Bushelpowered\Api\Quoting\V1\Enums\ServiceFeeType  $serviceType 
     * @param  string  $description 
     * @param  null|string  $serviceDate  of yyyy-MM-dd format, IE: 2023-10-04
     */
    public function __construct(?string $id, \Bushelpowered\Api\Quoting\V1\Enums\ServiceFeeType $serviceType, string $description, ?string $serviceDate)
    {
        $this->id = $id;
        $this->serviceType = $serviceType;
        $this->description = $description;
        $this->serviceDate = $serviceDate;
    }
    

}